



    void save_to_disk( ) 
    {
        //  Locals

        DWORD            dwDataSize;
        DWORD            dwWritten;
        HANDLE           hFile = INVALID_HANDLE_VALUE;
        BITMAPFILEHEADER bmfh = { 0 };

        //  Get the size of the resource data

        if( m_bIsFileDIB )
            dwDataSize = GlobalSize( m_hDIB );
        else
            dwDataSize = SizeofResource( 0, m_hResource );

        //  Create the file

        try
        {
            hFile = CreateFile( lpszFilename, GENERIC_WRITE, 0, 0,
                    CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0 );

            if( hFile == INVALID_HANDLE_VALUE )
                throw 0;


            bmfh.bfType = 0x4D42;
            bmfh.bfSize = dwDataSize + sizeof( BITMAPFILEHEADER );
            bmfh.bfOffBits = sizeof( BITMAPFILEHEADER );

            if( IsWin3DIB())
            {
                bmfh.bfOffBits += sizeof( BITMAPINFOHEADER );

                if( ColorDepth() <= 8 )
                    bmfh.bfOffBits += Colors() * sizeof( RGBQUAD );
            }
            else
            {
                bmfh.bfOffBits += sizeof( BITMAPCOREHEADER );

                if( ColorDepth() <= 8 )
                    bmfh.bfOffBits += Colors() * sizeof( RGBTRIPLE );
            }

        

            if( !WriteFile( hFile, &bmfh, sizeof( BITMAPFILEHEADER ), &dwWritten, 0 ))
                throw 0;

            if( dwWritten != sizeof( BITMAPFILEHEADER ))
                throw 0;

            //  Write the data to the datafile

            if( !WriteFile( hFile, (LPVOID) m_hDIB, dwDataSize, &dwWritten, 0 ))
                throw 0;

            if( dwWritten != dwDataSize )
                throw 0;



            CloseHandle( hFile );
            return true;
        }
        catch(...)
        {


            if( hFile != INVALID_HANDLE_VALUE )
                CloseHandle( hFile );

            return false;
        }
    }
