
#include <windows.h>
#include <math.h>
#include <stdio.h>

#include "display.h"

#include "input.h"


// mouse capture cords 
int mouse_start_x = 0, mouse_start_y = 0;
int mouse_is_down = 0;
int mouse_x, mouse_y;


/* save the parameters to disk */
void save_params( void )
{
    FILE *f = fopen("log.txt", "at");
    
   // fprintf(f, "K = (%f, %fi)\n", CR, CI);
    fprintf(f, "X = (%f, %f)\n", start_x, end_x);
    fprintf(f, "Y = (%f, %f)\n", start_y, end_y);
  
    fclose(f);   
}
/* end of save_parans */


/* capture mouse down , save the position*/
void mouse_down( LPARAM lParam )
{
    mouse_start_x = lParam & 0xffff;
    mouse_start_y = lParam >> 16;
    
    mouse_is_down = 1;
  
}
/* end of mouse_down */


/* capture mouse up */
void mouse_up( LPARAM lParam )
{
    unsigned int m_x =lParam & 0xffff;
    unsigned int m_y =lParam >> 16;

    double old_start_x = start_x, old_start_y = start_y;

    double x_range = end_x - start_x;
    double y_range = end_y - start_y;

    // create the new window 
    start_x = (mouse_start_x - 10) * (x_range) / (double)display_x + old_start_x;
    start_y = ( mouse_start_y) * (y_range) / (double)display_y + old_start_y;
    
    end_x = (m_x) * (x_range) / (double)display_x + old_start_x;
    end_y = ( m_y) * (y_range) / (double)display_y + old_start_y;

    double tmp;
    
    if (start_x > end_x)
    {
        tmp = start_x;
        start_x = end_x;
        end_x = tmp;
    }        

    if (start_y > end_y)
    {
        tmp = start_y;
        start_y = end_y;
        end_y = tmp;
    }        

    draw_fractal();
   
    mouse_start_x = 0;
    mouse_start_y = 0;
    
    mouse_is_down = 0;
}
/* end of mouse_up */



void mouse_move(LPARAM lParam)
{
    mouse_x = lParam & 0xffff;
    mouse_y = lParam >> 16;    
    
    InvalidateRect(main_win, NULL, FALSE);
}


/* called when a key is pressed */
void process_key_down(WPARAM wParam)
{
    // escape key
    if (wParam == VK_ESCAPE) { PostQuitMessage(0); return; }
    
    if (wParam == 112) save_params(); // save parameters to disk
            
     if (wParam == 81) display_info = !display_info;
  //  if (wParam == 65) CR *= 0.99;

   // if (wParam == 87) CI *= 1.01;
   // if (wParam == 83) CI *= 0.99;
    
  //  char ch[200];
  //  sprintf(ch, "%d",wParam);
  // MessageBox(main_win, ch, "key", 0);
    
    
    if (wParam == VK_SPACE)
    {
        start_x = -2;  start_y = -1;
        end_x = 1;  end_y = 1;
        max_it = 200;
    }

    if (wParam == VK_UP)
    {
        double y_range = end_y - start_y;
 
        start_y -= 0.05 * y_range;
        end_y -= 0.05 * y_range;
    }

    if (wParam == VK_DOWN)
    {
        double y_range = end_y - start_y;
 
        start_y += 0.05 * y_range;
        end_y += 0.05 * y_range;
    }

    if (wParam == VK_LEFT)
    {
        double x_range = end_x - start_x;
 
        start_x -= 0.05 * x_range;
        end_x -= 0.05 * x_range;
    }

    if (wParam == VK_RIGHT)
    {
        double x_range = end_x - start_x;
 
        start_x += 0.05 * x_range;
        end_x += 0.05 * x_range;
    }

    if (wParam == VK_END)
    {
        double x_range = end_x - start_x;
        double y_range = end_y - start_y;
 
        start_x -= 0.05 * x_range;
        start_y -= 0.05 * y_range;
        
        end_x += 0.05 * x_range;
        end_y += 0.05 * y_range;
    }

    if (wParam == VK_HOME)
    {
        double x_range = end_x - start_x;
        double y_range = end_y - start_y;
 
        start_x += 0.05 * x_range;
        start_y += 0.05 * y_range;
        
        end_x -= 0.05 * x_range;
        end_y -= 0.05 * y_range;
    }

    if (wParam == VK_INSERT) max_it += 10;
    if (wParam == VK_DELETE && max_it > 0) max_it -= 10;
 
  //if (wParam == VK_PRIOR) max_len *= 0.90;;
 //if (wParam == VK_NEXT && max_it > 0.001) max_len *= 1.10;
 
     draw_fractal();
}
/* end of process key down */


/* called when a key is released */
void process_key_up( WPARAM wParam )
{

}
/* end of process key up */




