
#include <windows.h>
#include <stdio.h>

#include "window.h"

#include "display.h"
#include "input.h"

#define ID_TIME   1


LARGE_INTEGER timer_freq;

HWND main_win = NULL;              // keep track of the main window

/* ran when window is created */
void system_startup(HWND hwnd)
{

    QueryPerformanceFrequency(&timer_freq);

    create_buffer();
    draw_fractal();

//    SetTimer(hwnd, ID_TIME, 50, NULL);
}
/* end of system_startup */


/* ran when window is closed */
void system_shutdown(void)
{
    destroy_buffer();

    PostQuitMessage(0);   
}
/* end of system_shutdown */


/* deal with the system timer */
/*void timer_message(WPARAM wParam)
{
    if (wParam == ID_TIME)
    {
        InvalidateRect(main_win, NULL, FALSE); 
    }
}*/
/* end of timer message */


/* the message handler */
LRESULT CALLBACK WinProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    switch (message)                 
    {
        case WM_CREATE:   system_startup(hwnd);    break;

       // case WM_NETEVENT: network_message(wParam, lParam); break;

//        case WM_TIMER:    timer_message(wParam); break;
        case WM_DESTROY:  system_shutdown(); break;

        case WM_MOUSEMOVE: mouse_move(lParam); break;
        case WM_LBUTTONDOWN: mouse_down(lParam); break;
        case WM_LBUTTONUP: mouse_up(lParam); break;

        case WM_KEYDOWN:  process_key_down(wParam); break;
        case WM_KEYUP:    process_key_up(wParam); break;

        case WM_PAINT:    display(); break;

        default: return DefWindowProc (hwnd, message, wParam, lParam);
    }

    return(0);
}
/* end of winproc */



/* winmain */
int WINAPI WinMain(HINSTANCE hinstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
    // make the main window
    if (setup_window(hinstance, nCmdShow)) return(1);

    MSG messages;

    while (GetMessage (&messages, NULL, 0, 0))
    {
        TranslateMessage(&messages);
        DispatchMessage(&messages);
    }

    return(messages.wParam);
}
/* end of winmain */

